; yCLOTHOCURVEz
; [U[͂ɊÂăN\ChȐ̃|C쐬
(defun C:CLOTHOCURVE (/ R A ptlist direction ucs_matrix)
  (setq R (getreal "\nI_̔aRmPʂœ:"))
  (setq A (getreal "\np[^AmPʂœ:"))
  (setq direction (getstring "\nN\Ch̉]I[(L)/E(R)]<(L)>:"))
  
  (setq ptlist (clothopoints R A))
  
  (if (null ptlist)
    (princ "\nN\ChȐ̐Ɏs܂B")
    (progn
      (if (or (eq direction "R") (eq direction "r"))
        (setq ptlist (mapcar '(lambda (pt) (list (car pt) (- (cadr pt)))) ptlist))
      )
      
      ; _̍Wl1000{
      (setq ptlist (mapcar '(lambda (pt) (mapcar '* pt '(1000 1000 1000))) ptlist))
      
      ; ݂UCSs擾
      (setq ucs_matrix (getvar "WORLDUCS"))
      
      ; UCSϊKp
      (setq ptlist (mapcar '(lambda (pt) (trans pt 1 ucs_matrix)) ptlist))
      
      ; CgEFCg|C쐬
      (entmake (append
                 (list
                   (cons 0 "LWPOLYLINE")
                   (cons 100 "AcDbEntity")
                   (cons 100 "AcDbPolyline")
                   (cons 90 (length ptlist))
                   (cons 70 0)
                 )
                 (apply 'append
                   (mapcar '(lambda (pt)
                              (list
                                (cons 10 pt)
                                (cons 40 0.0)
                                (cons 41 0.0)
                                (cons 42 0.0)
                                (cons 91 0)
                              )
                            )
                     ptlist
                   )
                 )
                 (list (cons 210 '(0.0 0.0 1.0)))
               )
      )
      
      (princ "\nN\ChȐ̃|C쐬܂B")
    )
  )
  (princ)
)

; ȗa R ƃN\Chp[^ A ɊÂăN\ChȐ̓_̃Xg𐶐
(defun clothopoints (R A / pts L s)
  (setq L (* (/ (expt A 2) R)))  ; N\ChȐ̑ŠvZ
  (setq pts nil)
  (setq s 0)
  
  (while (< s L)
    (setq pt (clothopoint R A s))
    (setq pts (cons pt pts))
    (setq s (+ s 1.0))
  )
  
  ; S L ɑΉ_̍Wǉ
  (setq pt (clothopoint R A L))
  (setq pts (cons pt pts))
  
  (reverse pts)
)

; ȗa RAN\Chp[^ AAȐ̋ s ɊÂăN\ChȐ̓_̍WvZ
(defun clothopoint (R A s / x y n h sx sy L)
  (setq L (* (/ (expt A 2) R)))  ; N\ChȐ̑ŠvZ
  (setq n 1000)  ; Ԃ̕
  (setq h (/ s n))  ; Ԃ̕
  
  ; `ɂ鐔lϕ
  (setq sx (trapezoid n h A 'clotho-x))
  (setq sy (trapezoid n h A 'clotho-y))
  
  (list sx sy)
)

; `̌vZ
(defun trapezoid (n h A fn)
  (setq sum 0)
  (setq u 0)
  (setq i 0)
  (repeat (1+ n)
    (if (or (= i 0) (= i n))
      (setq sum (+ sum (* 0.5 (apply fn (list u A)))))
      (setq sum (+ sum (apply fn (list u A))))
    )
    (setq u (+ u h))
    (setq i (1+ i))
  )
  (* h sum)
)

; N\ChȐxW̔ϕ֐
(defun clotho-x (u A)
  (cos (* 0.5 (/ (expt u 2) (expt A 2))))
)

; N\ChȐyW̔ϕ֐
(defun clotho-y (u A)
  (sin (* 0.5 (/ (expt u 2) (expt A 2))))
)

(princ "\nCLOTHOCURVE.lsp[h܂B")
(princ)
